jQuery(function($) {

    /***** new order form fields validation *****/
    function validateNewOrderFormFields() {
        var validationResult = {
            is_valid: true,
            msg: ""
        };

        $("#postchi_order_details_container .required").each(function() {
            if (!$(this).val()) {
                var err_element = $(this).parent().find(".err-msg");
                if (!err_element.length) {
                    $(this).parent().append("<div class='err-msg'></div>");
                }
                $(this).parent().find(".err-msg").html("وارد کردن این فیلد الزامی است.");
                $(this).addClass("err");

                validationResult.is_valid = false;
                validationResult.msg = "مقادیر الزامی را وارد کنید.";
            }
        });

        if (validationResult.is_valid) {
            $("#postchi_order_details_container .validate").each(function() {
                var validate_validationResult = validator($(this).val(), $(this).data("validate"));
                if (!validate_validationResult.is_valid) {
                    var err_element = $(this).parent().find(".err-msg");
                    if (!err_element.length) {
                        $(this).parent().append("<div class='err-msg'></div>");
                    }
                    $(this).parent().find(".err-msg").html(validate_validationResult.err_msg);
                    $(this).addClass("err");

                    validationResult.is_valid = false;
                    validationResult.msg = "لطفا خطاهای موجود را برطرف کنید.";
                }
            });
        }

        return validationResult;
    }
    /***** End: new order form fields validation *****/

    /***** blur inputs - validation *****/
    // validator 
    function validator(value, key) {
        var validationResult = {
            is_valid: "",
            err_msg: ""
        };

        switch (key) {
            case "email":
                var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
                var is_valid = re.test(value);
                var msg = "مقدار وارد شده معتبر نیست.";
                break;

            case "mobile":
                var re_1 = /^\d{11}$/;
                var is_valid_1 = re_1.test(value);
                var msg_1 = "طول شماره موبایل باید 11 رقم باشد.";

                var re_2 = /(0|\+98)?([ ]|-|[()]){0,2}9[0|1|2|3|4|9]([ ]|-|[()]){0,3}(?:[0-9]([ ]|-|[()]){0,2}){8}/ig;
                var is_valid_2 = re_2.test(value);
                var msg_2 = "مقدار وارد شده معتبر نیست.";

                var is_valid = is_valid_1 && is_valid_2;
                var msg = !is_valid_1 ? msg_1 : msg_2;
                break;

            case "number":
                var is_valid = !isNaN(value);
                var msg = "مقدار وارد شده معتبر نیست.";
                break;
        }

        validationResult.is_valid = is_valid;
        validationResult.err_msg = is_valid ? "" : msg;

        return validationResult;
    }


    
    $("body").on("click", "#downArrowOrderHistories img", function() {
        orderHistoryDropdownHandler();
        });





        function orderHistoryDropdownHandler () {
            $("#order-histories").slideToggle();


        }

    $("body").on("blur", "#postchi_order_details_container .required, #postchi_order_details_container .validate", function() {
        var err_element = $(this).parent().find(".err-msg");
        if ($(this).val()) {
            // not empty input
            var err_msg = "";
            if ($(this).hasClass('validate')) {
                var validationResult = validator($(this).val(), $(this).data("validate"));
                if (!validationResult.is_valid) {
                    err_msg = validationResult.err_msg;
                }
            }

            if (err_msg) {
                if (!err_element.length) {
                    $(this).parent().append("<div class='err-msg'></div>");
                }
                $(this).parent().find(".err-msg").html(err_msg);
                $(this).addClass("err");
            } else {
                if (err_element.length) {
                    $(this).parent().find(".err-msg").remove();
                }
                $(this).removeClass("err");
            }
        } else {
            // empty input
            if ($(this).hasClass('required')) {
                if (!err_element.length) {
                    $(this).parent().append("<div class='err-msg'></div>");
                }
                $(this).parent().find(".err-msg").html("وارد کردن این فیلد الزامی است.");
                $(this).addClass("err");
            }
        }
    });
    /***** End: blur inputs - validation *****/

    /***** Get Services *****/
    function getServices() {
        $("#admin_services_content_container").html('دریافت اطلاعات ...');
        $.ajax({
            type: "POST",
            url: $("#admin_ajax_url").val(),
            data: {
                action: "ajaxAdminPostbarServicesHTML",
                security: $("#nonce_ajaxAdminPostbarServicesHTML").val(),
                selected_ServiceId: $("#primary_selected_ServiceId").val(),
                ListType: 0,
                senderStateId: $("#Sender_StateId").val(),
                senderTownId: $("#Sender_townId").val(),
                boxType: $("#boxType").val(),
                receiver_ForeginCountry: '',
                receiverStateId: $("#Reciver_StateId").val(),
                receiverTownId: $("#Reciver_townId").val(),
                weightItem: $("#Weight").val(),
                AproximateValue: $("#ApproximateValue").val(),
                height: $("#height").val(),
                width: $("#width").val(),
                length: $("#length").val(),
                Content: $("#GoodsType").val(),
                dispatch_date: '',
                TruckType: '',
                VechileOptions: '',
                PackingLoad: '',
                IsCOD: $("#IsCOD").val()
            },
            success: function(result) {
                $("#admin_services_content_container").html(result);
            }
        });
    }
    $(document).ready(function() { getServices(); });
    /***** Get Services *****/

    /***** Set InsuranceName *****/
    function setInsuranceName() {
        var InsuranceName = $("#InsuranceId").children(':selected').html();
        $("#InsuranceName").val(InsuranceName);
    }
    $("#InsuranceId").change(function() { setInsuranceName(); });
    $(document).ready(function() { setInsuranceName(); });
    /***** End: Set InsuranceName *****/

    /***** Set CartonSizeName *****/
    function setCartonSizeName() {
        var CartonSizeName = $("#CartonSizeId").children(':selected').html();
        $("#CartonSizeName").val(CartonSizeName);
    }
    $("#CartonSizeId").change(function() { setCartonSizeName(); });
    $(document).ready(function() { setCartonSizeName(); });
    /***** End: Set CartonSizeName *****/

    /***** Change State *****/
    $("#Sender_StateId").on('change', function() {
        $("#Sender_townId").html('<option>دریافت اطلاعات ...</option>');
        $.ajax({
            type: "POST",
            url: $("#admin_ajax_url").val(),
            data: {
                action: "ajaxPostbarStateTownsHTML",
                security: $("#nonce_ajaxPostbarStateTownsHTML").val(),
                stateId: $(this).val()
            },
            success: function(result) {
                $("#Sender_townId").html(result);
                getServices();
            }
        });
    });
    $("#Reciver_StateId").on('change', function() {
        $("#Reciver_townId").html('<option>دریافت اطلاعات ...</option>');
        $.ajax({
            type: "POST",
            url: $("#admin_ajax_url").val(),
            data: {
                action: "ajaxPostbarStateTownsHTML",
                security: $("#nonce_ajaxPostbarStateTownsHTML").val(),
                stateId: $(this).val()
            },
            success: function(result) {
                $("#Reciver_townId").html(result);
                getServices();
            }
        });
    });
    /***** End: Change State *****/

    /***** Change Town *****/
    $("#Sender_townId").on('change', function() { getServices(); });
    $("#Reciver_townId").on('change', function() { getServices(); });
    /***** End: Change Town *****/

    /***** Change Service *****/
    $("body").on('change', "input[name=ServiceId]", function() {
        //Insurance
        $("#InsuranceId").html('<option>دریافت اطلاعات ...</option>');
        $.ajax({
            type: "POST",
            url: $("#admin_ajax_url").val(),
            data: {
                action: "ajaxPostbarInsurancesHTML",
                security: $("#nonce_ajaxPostbarInsurancesHTML").val(),
                serviceId: $("input[name=ServiceId]:checked").val()
            },
            success: function(result) {
                // $("#InsuranceId").html(result);
                // setInsuranceName();
            }
        });

        //CartonSize
        // $("#CartonSizeId").html('<option>دریافت اطلاعات ...</option>');
        // $.ajax({
        //     type: "POST",
        //     url: $("#admin_ajax_url").val(),
        //     data: {
        //         action: "ajaxPostbarCartonSizeHTML",
        //         security: $("#nonce_ajaxPostbarCartonSizeHTML").val(),
        //         serviceId: $("input[name=ServiceId]:checked").val()
        //     },
        //     success: function(result) {
        //         $("#CartonSizeId").html(result);
        //         setCartonSizeName();
        //     }
        // });
    });
    /***** End: Change Service *****/

    /***** Send Order To Postchi *****/
    $("#submit_order_postchi").on("click", function(e) {
        e.preventDefault();
        if (confirm('آیا از  صحت داده ها و ثبت سفارش در سامانه باربری اطمینان دارید؟')) {
            var checkFormValidation = validateNewOrderFormFields();
            if (checkFormValidation.is_valid) {
                $("#postchi_shipping_loading").show();
                $.ajax({
                    type: "POST",
                    url: $("#admin_ajax_url").val(),
                    data: {

                        action: 'ajaxPostbarNewOrder',
                        security: $("#nonce_ajaxPostbarNewOrder").val(),
                        woo_post_id: $("#postchi_post_id").val(),

                        //فروشنده
                        Sender_FristName: $("#Sender_FristName").val(),
                        Sender_LastName: $("#Sender_LastName").val(),
                        Sender_mobile: $("#Sender_mobile").val(),
                        Sender_StateId: $("#Sender_StateId").val(),
                        Sender_townId: $("#Sender_townId").val(),
                        Sender_City: $("#Sender_City").val(),
                        Sender_PostCode: $("#Sender_PostCode").val(),
                        Sender_Address: $("#Sender_Address").val(),
                        Sender_Email: $("#Sender_Email").val(),
                        SenderLat: $("#SenderLat").val(),
                        SenderLon: $("#SenderLon").val(),
                        InsuranceName: $("#InsuranceName").val(),
                        CartonSizeName: $("#CartonSizeName").val(),
                        boxType: $("#boxType").val(),
                        HasAccessToPrinter: $("#HasAccessToPrinter").val(),
                        AgentSaleAmount: $("#AgentSaleAmount").val(),
                        printLogo: $("#printLogo").val(),
                        notifBySms: $("#notifBySms").val(),
                        discountCouponCode: $("#discountCouponCode").val(),


                        //خریدار
                        ServiceId: $("input[name=ServiceId]:checked").val(),
                        Reciver_FristName: $("#Reciver_FristName").val(),
                        Reciver_LastName: $("#Reciver_LastName").val(),
                        Reciver_mobile: $("#Reciver_mobile").val(),
                        receiver_ForeginCountry: '',
                        receiver_ForeginCountryName: '',
                        Reciver_StateId: $("#Reciver_StateId").val(),
                        Reciver_townId: $("#Reciver_townId").val(),
                        Reciver_City: $("#Reciver_City").val(),
                        Reciver_PostCode: $("#Reciver_PostCode").val(),
                        Reciver_Address: $("#Reciver_Address").val(),
                        Reciver_Email: $("#Reciver_Email").val(),
                        IsCOD: $("#IsCOD").val(),


                        //کالا
                        GoodsType: $("#GoodsType").val(),
                        ApproximateValue: $("#ApproximateValue").val(),
                        CodGoodsPrice: $("#CodGoodsPrice").val(),
                        Weight: $("#Weight").val(),
                        length: $("#length").val(),
                        width: $("#width").val(),
                        height: $("#height").val(),
                        Count: $("#Count").val(),

                        //حمل و نقل سنگین    
                        UbbraTruckType: "", //req if heavy 1
                        VechileOptions: "", //req if heavy 1
                        UbbarPackingLoad: "", //req if heavy 1
                        dispatch_date: "", //req if heavy 1
                    },
                    success: function(response) {
                        var result = JSON.parse(response);
                        $("#postchi_shipping_loading").hide();
                        if (result.status == "success") {
                            var successMessage = result.message + "<br />";
                            successMessage = successMessage + "سفارش شما در سامانه باربری پستچی با شناسه " + result.orderId + " به ثبت رسید.";
                            var invoice_link = result.site_url + "/wp-content/plugins/postchi-shipping/inc/orederInvoice.php?orderid=" + result.orderId + "&token=" + result.token;
                            successMessage = successMessage + "<div class='postchi-mt-15'><a class='postchi-pdf-btn' href='" + invoice_link + "' target='_blank'>دریافت فاکتور</a></div>";
                            $("#postchiNewOrderMessage").html(successMessage);
                        } else {
                            $("#postchiNewOrderMessage").html(result.message);
                        }
                    }
                });
            } else {
                alert(checkFormValidation.msg);
            }
        } else {
            // Do nothing!
        } // End Confirmation
    });
    /***** End: Send Order To Postchi *****/

    /***** Other Events to call Get Services *****/
    $("#boxType").on('change', function() { getServices(); });
    $("#Weight, #length, #width, #height").on('keyup', function() { getServices(); });
    /***** End : Other Events to call Get Services *****/

    /**** Change payment method *****/
    function handlePaymentMethod() {
        if ($("#IsCOD").val() == "true")
            $("#CodGoodsPrice_row").show();
        else
            $("#CodGoodsPrice_row").hide();
    }
    $(document).ready(function() { handlePaymentMethod(); });
    $("#IsCOD").on('change', function() {
        handlePaymentMethod();
        getServices();
    });
    /**** End: Change payment method *****/

}); // End jQuery;