function postchiErrNotify(errors) {
    if (errors) {
        var container_element = document.getElementById("postchi_errs_ntfy_container");
        if (!container_element) {
            container_element = document.createElement("div");
            container_element.setAttribute("id", "postchi_errs_ntfy_container");
            document.body.appendChild(container_element);
        }
        for (var i = 0; i < errors.length; i++) {
            var child_node = document.createElement("div");
            child_node.setAttribute("class", "postchi-err-holder");
            var closer = "<div class='postchi-err-holder-closer' onclick='postchiCloseErr(this)'>x</div>";
            var errContent = "<div class='postchi-err-content'>اخطار پستچی : " + errors[i] + "</div>";
            child_node.innerHTML = closer + errContent;
            container_element.appendChild(child_node);
        }
    }
}

function postchiCloseErr(e) {
    e.parentNode.parentNode.removeChild(e.parentNode);
}


jQuery(function($) {

    /***** Get Shipping Services By Ajax *****/
    function getShippingServices() {
        if ($("#shipping_rows_container").length) {
            $("#shipping_rows_container").html('درحال دریافت اطلاعات ...');
            $.ajax({
                type: "POST",
                url: $("#postchiShippingModalAjaxUrl").val(),
                data: {
                    action: "ajaxPostbarServicesHTML",
                    security: $("#nonce_ajaxPostbarServicesHTML").val(),
                    postchi_reciever_stateId: $("#postchi_reciever_stateId").val(),
                    postchi_reciever_townId: $("#postchi_reciever_townId").val(),
                    postchi_reciever_listType: $("#postchi_reciever_listType").length ? $("#postchi_reciever_listType").val() : 0,
                    postchi_UserSelected_ServiceId: $("input[name=postchi_UserSelected_ServiceId]").length ? $("input[name=postchi_UserSelected_ServiceId]:checked").val() : 0,
                    postchi_IsCOD: $("#postchi_IsCOD").length ? $("#postchi_IsCOD").val() : 0,
                },
                success: function(result) {
                    $("#shipping_rows_container").html(result);
                }
            });
        }
    }
    /***** End: Get Shipping Services By Ajax *****/

    /***** check conditional shipping *****/
    function checkConditionalShipping() {
        //hide elements
        $("#postchi_reciever_listType_container").hide();
        $("#postchi_IsCOD_container").hide();
        $("#postchi_shipping_services_container").hide();

        //show message
        $("#postchi_reciever_listType_container").before("<div id='postchi_checkConditionalShipping_msg'>در حال بررسی سرویسهای حمل و نقل ...</div>");

        //check is there a condition by ajax
        $.ajax({
            type: "POST",
            url: $("#postchiShippingModalAjaxUrl").val(),
            data: {
                action: "ajaxCheckConditionalShipping",
                security: $("#nonce_ajaxCheckConditionalShipping").val(),
                postchi_reciever_stateId: $("#postchi_reciever_stateId").val(),
                postchi_reciever_townId: $("#postchi_reciever_townId").val(),
            },
            success: function(result) {
                $("#postchi_checkConditionalShipping_msg").remove();
                if (result == "false") {
                    $("#postchi_reciever_listType_container").show();
                    $("#postchi_IsCOD_container").show();
                    $("#postchi_shipping_services_container").show();
                }
            }
        });
    }
    /***** End: check conditional shipping *****/

    // Shipping Modal Selectors
    if ($("#postchi-shipping-modal-selector").length) {
        /***** open modal *****/
        $('body').on('click', '#postchi_shipping_open_modal', function(e) {
            e.preventDefault();
            $('#postchiShippingModalSelector_container').show();
            checkConditionalShipping();
        });
        $('.postchi-checkout-change-statecity #postchi_shipping_open_modal').click(function(e) {
            e.preventDefault();
            $('#postchiShippingModalSelector_container').show();
            checkConditionalShipping();
        });
        /***** End: open modal *****/

        /***** close modal or cancel *****/
        $('#postchi-close-modal-icon, #postchi_modal_btn_cancel').click(function(e) {
            e.preventDefault();
            $('#postchiShippingModalSelector_container').hide();
        });
        /***** End: close modal or cancel *****/

        /***** Change State *****/
        $("body").on('change', "#postchi_reciever_stateId", function() {
            $("#postchi_reciever_townId").html('<option>دریافت اطلاعات ...</option>');
            $.ajax({
                type: "POST",
                url: $("#postchiShippingModalAjaxUrl").val(),
                data: {
                    action: "ajaxPostbarStateTownsHTML",
                    security: $("#nonce_ajaxPostbarStateTownsHTML").val(),
                    stateId: $(this).val()
                },
                success: function(result) {
                    $("#postchi_reciever_townId").html(result);
                    checkConditionalShipping();
                    getShippingServices();
                }
            });
        });
        /***** End: Change State *****/

        /***** Change Town *****/
        $("body").on("change", "#postchi_reciever_townId", function() { checkConditionalShipping();
            getShippingServices(); });
        /***** End: Change Town *****/

        /***** Change List Type *****/
        $("body").on("change", "#postchi_reciever_listType", function() { getShippingServices(); });
        /***** End: Change List Type *****/

        /***** Change payment method *****/
        $("body").on("change", "#postchi_IsCOD", function() { getShippingServices(); });
        /***** End: Change payment method *****/

        /***** Click on shipping rows *****/
        $("body").on("click", "#shipping_rows_container .shipping-row", function() {
            $(this).find("input[type=radio]").prop("checked", true);
        });
        /***** End: Click on shipping rows *****/



        /***** modal confirm changes *****/
        function postchi_modal_confirm_changes() {
            //loading on 
            $("#postchi_modal_btn_save").addClass('loading');

            //set sission
            var PUSID_element = $("input[name=postchi_UserSelected_ServiceId]").length;
            $.ajax({
                type: "POST",
                url: $("#postchiShippingModalAjaxUrl").val(),
                data: {
                    action: "ajaxPostbarSetSessions",
                    security: $("#nonce_ajaxPostbarSetSessions").val(),
                    postchi_reciever_stateId: $("#postchi_reciever_stateId").val(),
                    postchi_reciever_stateTitle: $("#postchi_reciever_stateId option:selected").text(),
                    postchi_reciever_townId: $("#postchi_reciever_townId").val(),
                    postchi_reciever_townTitle: $("#postchi_reciever_townId option:selected").text(),
                    postchi_reciever_listType: $("#postchi_reciever_listType").length ? $("#postchi_reciever_listType").val() : 0,
                    postchi_UserSelected_ServiceId: PUSID_element ? $("input[name=postchi_UserSelected_ServiceId]:checked").val() : 0,
                    postchi_UserSelected_ServicePrice: PUSID_element ? $("input[name=postchi_UserSelected_ServiceId]:checked").data('price') : 0,
                    postchi_UserSelected_ServiceTitle: PUSID_element ? $("input[name=postchi_UserSelected_ServiceId]:checked").data('title') : 0,
                    postchi_IsCOD: $("#postchi_IsCOD").length ? $("#postchi_IsCOD").val() : 0,
                },
                success: function(result) {
                    //loading off
                    $("#postchi_modal_btn_save").removeClass('loading');

                    //close modal
                    $('#postchiShippingModalSelector_container').hide();

                    //calculate shipping cost
                    if ($('#postchi-cart-shipping-calc-form').length) {
                        $("#postchi-cart-shipping-calc-form").submit();
                    }
                    if ($('form.checkout').length) {
                        $('body').trigger('update_checkout');
                        //hidden inputs
                        $("input[name=billing_postchi_reciever_stateId]").val($("#postchi_reciever_stateId").val());
                        $("input[name=billing_postchi_reciever_townId]").val($("#postchi_reciever_townId").val());
                        $("input[name=billing_postchi_UserSelected_ServiceId]").val(PUSID_element ? $("input[name=postchi_UserSelected_ServiceId]:checked").val() : 0);
                        $("#billing_state").val($("#postchi_reciever_stateId option:selected").text());
                        $("#billing_city").val($("#postchi_reciever_townId option:selected").text());
                        //disabled selects
                        $("#billing_postchi_reciever_stateId option:selected").val($("#postchi_reciever_stateId").val());
                        $("#billing_postchi_reciever_stateId option:selected").text($("#postchi_reciever_stateId option:selected").text());
                        $("#billing_postchi_reciever_townId option:selected").val($("#postchi_reciever_townId").val());
                        $("#billing_postchi_reciever_townId option:selected").text($("#postchi_reciever_townId option:selected").text());
                    }
                }
            });
        }
        $("#postchi_modal_btn_save").click(function(e) {
            e.preventDefault();
            postchi_modal_confirm_changes();
        });
        /***** End: modal confirm changes *****/

        /***** primary data of state and town in checkout *****/
        if ($('form.checkout').length) {
            $(document).ready(function() {
                $("#billing_state").val($("#postchi_reciever_stateId option:selected").text());
                $("#billing_city").val($("#postchi_reciever_townId option:selected").text());
            });
        }
        /***** End: primary data of state and town in checkout *****/

        /***** cart update by quantity *****/
        var should_get_postchi_services = false;
        $('.woocommerce').on('change', 'input.qty', function() {

            should_get_postchi_services = true;

            if (cart_update_timeout !== undefined) {
                clearTimeout(cart_update_timeout);
            }

            var cart_update_timeout = setTimeout(function() {
                $(".woocommerce [name='update_cart']").trigger("click");
            }, 1500);

        });

        $(document.body).on('updated_cart_totals', function() {
            if (should_get_postchi_services) {
                should_get_postchi_services = false;
                checkConditionalShipping();
                getShippingServices();
                postchi_modal_confirm_changes();
            }
        });
        /***** End: cart update by quantity *****/

    }


});