<?php

// Customer Order Details 
add_action( 'woocommerce_order_items_table', 'postchi_woocommerce_order_items_table', 10, 1 ); 

function postchi_woocommerce_order_items_table( $order ) 
{
    $woo_order_id = $order->get_id();
    $postchi_orderId = get_post_meta( $woo_order_id, 'postchi_orderId', true );
    $postchiTrackingResult = is_numeric($postchi_orderId) ? Postbar_API::orderTracking( $postchi_orderId ) : '';
    

    if( is_object($postchiTrackingResult) )
    {
        if($postchiTrackingResult->success)
        {
            $shipmentStatus = $postchiTrackingResult->history[0]->status;
            $TrackingNumber = $postchiTrackingResult->data->data[0]->TrackingNumber;
        }
        else
        {
            $shipmentStatus = $postchiTrackingResult->data->message;
            $TrackingNumber = "-";
        }
    }
    else
    {
        $shipmentStatus = "سفارش شما هنوز در سامانه باربری ثبت نشده است و در حال بررسی جهت ارسال به باربری می‌باشد.";
        $postchi_orderId = "-";
        $TrackingNumber = "-";
    }
    ?>

    <div id='postchi_order_traching'>
        <div id="pshot-header">
            <h5>وضعیت حمل و نقل مرسوله</h5>
            <?php
    echo print_r($postchiTrackingResult);
    die();
            ?>
        </div>
        <div id="pshot-body">
            <div class="img-container"></div>
            <div>
                <div class="pshot-info-row">
                    <b>آخرین وضعیت :</b>  
                    <span><?php echo $shipmentStatus; ?></span>
                </div>
                <div class="pshot-info-row">
                    <b>شناسه سفارش : </b>  
                    <span><?php echo $postchi_orderId; ?></span>                   
                </div>  
                <div class="pshot-info-row">
                    <b>کد رهگیری پستی :</b>  
                    <span><?php echo $TrackingNumber; ?></span> 
                </div>
                <div class="pshot-info-row">
                    <a href="https://postchi.ir" target="_blank">رهگیری مرسوله</a>
                    در سایت باربری
                </div>
            </div>
        </div>
    </div>

    <?php

}