<?php

function postchi_woo_shipping_menu() {
    add_menu_page(
        'حمل و نقل پستچی',
        'پستچی',
        'manage_options',
        'woo-postchi-settings',
        'postchi_woo_shipping_options',
        PostchiShipping::plugin_url() . '/assets/images/postchi-small.png',
        56
    );
    add_submenu_page( 'woo-postchi-settings', 'تنظیمات پستچی', 'تنظیمات', 'manage_options', 'woo-postchi-settings', "postchi_woo_shipping_options" );
    add_submenu_page( 'woo-postchi-settings', 'راهنمای پستچی', 'راهنما', 'manage_options', 'woo-postchi-help', "postchi_woo_shipping_help" );
    add_submenu_page( 'woo-postchi-settings', 'راهنمای پستچی', 'قوانین و مقررات', 'manage_options', 'woo-postchi-terms', "postchi_woo_shipping_terms" );

	add_action( 'admin_init', 'register_postchi_woo_shipping_settings' );
}
function register_postchi_woo_shipping_settings() {
	register_setting( 'postchi_woo_shipping-settings-group', 'postchi_woo_shipping_opts' );
}
add_action( 'admin_menu', 'postchi_woo_shipping_menu' );


// Postchi Settings
function postchi_woo_shipping_options() {
	if ( !current_user_can( 'manage_options' ) )  {
		wp_die( __( 'شما سطح دسترسی لازم برای مشاهده این قسمت را ندارید.' ) );
	}
    ?>

    <!-- wrap -->
	<div class="wrap">
        <form method="post" action="options.php">
        
            <?php 
                settings_fields( 'postchi_woo_shipping-settings-group' ); 
                do_settings_sections( 'postchi_woo_shipping-settings-group' ); 

                $postchi_username = get_option('postchi_woo_shipping_opts')["postchi_username"];
                $postchi_password = get_option('postchi_woo_shipping_opts')["postchi_password"];
                $postchi_token = get_option('postchi_woo_shipping_token');


                $postchi_user = new stdClass();
                if($postchi_username && $postchi_password)
                {
                    $postchi_user_data = Postbar_API::login($postchi_username, $postchi_password);
                    // die(json_encode($postchi_user_data->data));
                    if($postchi_user_data->success && $postchi_user_data->data->user->token)
                    {
                        update_option( 'postchi_woo_shipping_token', $postchi_user_data->data->user->token );
                        $postchi_user = $postchi_user_data->data;
                    }
                    else
                    {
                        ?>
                        <script>
                            jQuery(function($){
                                $(document).ready(function(){
                                    postchiErrNotify(<?php echo json_encode($postchi_user_data->errors); ?>);
                                });
                            });
                        </script>
                        <?php
                        update_option( 'postchi_woo_shipping_token', '' );
                    }
                }
                else
                {
                    update_option( 'postchi_woo_shipping_token', '' );
                }

                $postchi_token = get_option('postchi_woo_shipping_token');
                
            
                include_once( PostchiShipping::plugin_path() . '/inc/postchi-admin-settings-header.php' ); 
                include_once( PostchiShipping::plugin_path() . '/inc/postchi-admin-settings-user-data.php' ); 
                include_once( PostchiShipping::plugin_path() . '/inc/postchi-admin-settings-sender.php' ); 
                include_once( PostchiShipping::plugin_path() . '/inc/postchi-admin-settings-receiver.php' ); 
                include_once( PostchiShipping::plugin_path() . '/inc/postchi-admin-settings-defaults.php' ); 
            ?>

        </form>
    </div>
    <!-- End: wrap -->
    
	<?php
}

include_once( PostchiShipping::plugin_path() . '/inc/postchi-admin-help.php' );
include_once( PostchiShipping::plugin_path() . '/inc/postchi-admin-terms.php' );