<?php

function postchi_shipping_modal_selector() { 

    // ajax and nonces
    $shippingModalAjaxUrl = admin_url('admin-ajax.php');
    $nonce_ajaxCheckConditionalShipping = wp_create_nonce( "nonce-ajaxCheckConditionalShipping" );
    $nonce_ajaxPostbarSetSessions = wp_create_nonce( "nonce-ajaxPostbarSetSessions" );
    $nonce_ajaxPostbarStateTownsHTML = wp_create_nonce( "nonce-ajaxPostbarStateTownsHTML" );
    $nonce_ajaxPostbarServicesHTML = wp_create_nonce( "nonce-ajaxPostbarServicesHTML" ); 

    // set default sessions
    if(!WC()->session->get( 'postchi_reciever_stateId', 0 ))
    {
        WC()->session->set("postchi_reciever_stateId", get_option('postchi_woo_shipping_opts')["reciver_default_stateId"] ); 
    }
    if(!WC()->session->get( 'postchi_reciever_townId', 0 ))   
    {
        WC()->session->set("postchi_reciever_townId", get_option('postchi_woo_shipping_opts')["reciver_default_townId"] );
    }        

    //state and town
    $postchi_reciever_stateId = WC()->session->get( 'postchi_reciever_stateId', 0 ) ? WC()->session->get( 'postchi_reciever_stateId', 0 ) : get_option('postchi_woo_shipping_opts')["reciver_default_stateId"];
    $postchi_reciever_townId = WC()->session->get( 'postchi_reciever_townId', 0 ) ? WC()->session->get( 'postchi_reciever_townId', 0 ) : get_option('postchi_woo_shipping_opts')["reciver_default_townId"];
    $states_options = postchiStatesHTML($postchi_reciever_stateId);
    $towns_options = postchiStateTownsHTML($postchi_reciever_townId , $postchi_reciever_stateId);
        
    $shippingPriceCalcType = get_option('postchi_woo_shipping_opts')["shippingPriceCalcType"];
    if( $shippingPriceCalcType == "1" )
    {
        // payment methods
        $enabled_payments = enabled_payments();
        if( $enabled_payments->bothEnabled )
        {
            $is_COD = WC()->session->get( 'postchi_IsCOD', 0 ) ? WC()->session->get( 'postchi_IsCOD', 0 ) : 'false';
        }
        else
        {
            $is_COD = $enabled_payments->singleEnabled == 'cod' ? 'true' : 'false';
        }

        // listType        
        $postchi_reciever_listType = (get_option('postchi_woo_shipping_opts')["ListTypeSelectable"] && WC()->session->get( 'postchi_reciever_listType', 0 )) ? WC()->session->get( 'postchi_reciever_listType', 0 ) : get_option('postchi_woo_shipping_opts')["ListType"];

        // shipping Service
        $postchi_UserSelected_ServiceId = WC()->session->get( 'postchi_UserSelected_ServiceId', 0 ) ? WC()->session->get( 'postchi_UserSelected_ServiceId', 0 ) : '';
        $services_items = postchiServicesHTML($postchi_reciever_stateId, $postchi_reciever_townId, $postchi_reciever_listType, $postchi_UserSelected_ServiceId, $is_COD);
        
        // ListType filter
        $ListTypeSelectable = get_option('postchi_woo_shipping_opts')["ListTypeSelectable"];
        if($ListTypeSelectable)
        {
            $ListType = WC()->session->get( 'postchi_reciever_listType', 0 ) ? WC()->session->get( 'postchi_reciever_listType', 0 ) : get_option('postchi_woo_shipping_opts')["ListType"];
            $all_selected = "";
            $fastest_selected = "";
            $cheapest_selected = "";
            if($ListType=="1")
                $fastest_selected = "selected";
            if($ListType=="2")
                $cheapest_selected = "selected";
            $listTypes_html = "
            <!--
                <div id='postchi_reciever_listType_container' class='postchi-act-form-control'>
                    <label for='postchi_reciever_listType'>فیلتر سرویس ها</label>                         
                    <select id='postchi_reciever_listType'>
                        <option value='0' $all_selected >همه سرویس ها</option>
                        <option value='1' $fastest_selected >سریع ترین</option>
                        <option value='2' $cheapest_selected >ارزان ترین</option>
                    </select>
                </div>
                -->
            ";
        }
        else
        {
            $listTypes_html = "";
        }

        // cod filter
        if( $enabled_payments->bothEnabled )
        {
            $cod_selected = (WC()->session->get( 'postchi_IsCOD', 0 ) && WC()->session->get( 'postchi_IsCOD', 0 )=='true') ? 'selected' : '';
            $online_selected = $cod_selected == 'selected' ? '' : 'selected';

            $isCOD_html = "
                <div id='postchi_IsCOD_container' class='postchi-act-form-control'>
                    <label for='postchi_IsCOD'>نوع پرداخت</label>                         
                    <select id='postchi_IsCOD'>
                        <option value='false' $online_selected >پرداخت آنلاین (پیش کرایه)</option>
                        <option value='true' $cod_selected >پرداخت در محل (پس کرایه)</option>
                    </select>
                </div>
            ";
        }
        else
        {
            $isCOD_html = "";
        }

        $PACT_html = "
        <div id='postchiShippingModalSelector_container'>
            <div id='postchi-shipping-modal-selector'>
                <input type='hidden' id='postchiShippingModalAjaxUrl' value='$shippingModalAjaxUrl' />
                <input type='hidden' id='nonce_ajaxCheckConditionalShipping' value='$nonce_ajaxCheckConditionalShipping' />
                <input type='hidden' id='nonce_ajaxPostbarSetSessions' value='$nonce_ajaxPostbarSetSessions' />
                <input type='hidden' id='nonce_ajaxPostbarStateTownsHTML' value='$nonce_ajaxPostbarStateTownsHTML' />
                <input type='hidden' id='nonce_ajaxPostbarServicesHTML' value='$nonce_ajaxPostbarServicesHTML' />
                <div id='postchi_services_header'>
                    <div id='postchi-close-modal-icon'></div>
                    <h3>انتخاب سرویس حمل و نقل</h3>
                </div>
                <div id='postchi_services_content' class='shipping-info-content'>
                    <p>
                        <b>توجه : </b>
                        هزینه ارسال کالا، وابسته به محل دریافت شما میباشد. لطفا محل دریافت کالا را تعیین کرده و سپس از بین سرویس های پستی، یک گزینه را انتخاب کنید.
                    </p>
                    <div class='form-items'>
                        <div class='postchi-act-form-control'>
                            <label for='postchi_reciever_stateId'>استان</label>
                            <select id='postchi_reciever_stateId'>
                                $states_options
                            </select>
                        </div>
                        <div class='postchi-act-form-control'>
                            <label for='postchi_reciever_townId'>شهرستان</label>                         
                            <select id='postchi_reciever_townId'>
                                $towns_options
                            </select>
                        </div> 
                        $listTypes_html 
                        $isCOD_html
                    </div>
                    <div id='postchi_shipping_services_container' class='shipping-services-types-table'>
                        <div class='title-label'>سرویس های پستی موجود</div>
                        <div class='shipping-row titles'>
                            <div class='shipping-selection'>انتخاب</div>
                            <div class='shipping-details'>
                            <div class='details-item'></div>

                                <div class='details-item'>نام سرویس</div>
                                <div class='details-item'> بازه تقریبی ارسال (روز)</div>
                                <div class='details-item'>قیمت (ریال)</div>
                            </div>                
                        </div>
                        <div id='shipping_rows_container'>$services_items</div>                
                    </div>
                </div>       
                <div class='postchi-modal-footer'>
                    <button id='postchi_modal_btn_cancel'>انصراف</button>
                    <button id='postchi_modal_btn_save' class='postchi-btn-has-loading'>
                        <span class='postchi-btn-loading'></span>
                        <span class='postchi-btn-txt'>تایید</span>
                    </button>
                </div> 
            </div>
        </div>";
    } 
    else
    {
        $PACT_html = "
        <div id='postchiShippingModalSelector_container'>
            <div id='postchi-shipping-modal-selector'>
                <input type='hidden' id='postchiShippingModalAjaxUrl' value='$shippingModalAjaxUrl' />
                <input type='hidden' id='nonce_ajaxPostbarSetSessions' value='$nonce_ajaxPostbarSetSessions' />
                <input type='hidden' id='nonce_ajaxPostbarStateTownsHTML' value='$nonce_ajaxPostbarStateTownsHTML' />
                <div id='postchi_services_header'>
                    <div id='postchi-close-modal-icon'></div>
                    <h3>انتخاب مقصد حمل و نقل</h3>
                </div>
                <div id='postchi_services_content' class='shipping-info-content'>
                    <p>
                        <b>توجه : </b>
                        لطفا محل دریافت کالا را تعیین کنید.
                    </p>
                    <div class='form-items'>
                        <div class='postchi-act-form-control'>
                            <label for='postchi_reciever_stateId'>استان</label>
                            <select id='postchi_reciever_stateId'>
                                $states_options
                            </select>
                        </div>
                        <div class='postchi-act-form-control'>
                            <label for='postchi_reciever_townId'>شهرستان</label>                         
                            <select id='postchi_reciever_townId'>
                                $towns_options
                            </select>
                        </div>
                    </div>
                </div>       
                <div class='postchi-modal-footer'>
                    <button id='postchi_modal_btn_cancel'>انصراف</button>
                    <button id='postchi_modal_btn_save' class='postchi-btn-has-loading'>
                        <span class='postchi-btn-loading'></span>
                        <span class='postchi-btn-txt'>تایید</span>
                    </button>
                </div> 
            </div>
        </div>";
    } // End if shippingPriceCalcType == 1

    echo $PACT_html;        
    
};
         
// add the action 
add_action( 'woocommerce_before_cart', 'postchi_shipping_modal_selector' ); 
add_action( 'woocommerce_before_checkout_form', 'postchi_shipping_modal_selector' );