<?php


// set postchi session
add_action( 'wp_ajax_ajaxPostbarSetSessions', 'ajaxPostbarSetSessions' );
add_action( 'wp_ajax_nopriv_ajaxPostbarSetSessions', 'ajaxPostbarSetSessions' );
function ajaxPostbarSetSessions() 
{
    check_ajax_referer( 'nonce-ajaxPostbarSetSessions', 'security' );
    
    $postchi_reciever_stateId = $_POST["postchi_reciever_stateId"] ? intval($_POST["postchi_reciever_stateId"]) : get_option('postchi_woo_shipping_opts')["reciver_default_stateId"];
    $postchi_reciever_stateTitle = $_POST["postchi_reciever_stateTitle"] ? wp_kses($_POST["postchi_reciever_stateTitle"] , array()) : get_option('postchi_woo_shipping_opts')["reciver_default_stateTitle"];
    $postchi_reciever_townId = $_POST["postchi_reciever_townId"] ? intval($_POST["postchi_reciever_townId"]) : get_option('postchi_woo_shipping_opts')["reciver_default_townId"];    
    $postchi_reciever_townTitle = $_POST["postchi_reciever_townTitle"] ? wp_kses($_POST["postchi_reciever_townTitle"] , array()) : get_option('postchi_woo_shipping_opts')["reciver_default_townTitle"];    
    $postchi_reciever_listType = get_option('postchi_woo_shipping_opts')["ListTypeSelectable"] ? intval($_POST["postchi_reciever_listType"]) : get_option('postchi_woo_shipping_opts')["ListType"];
    $postchi_UserSelected_ServiceId = $_POST["postchi_UserSelected_ServiceId"] ? intval($_POST["postchi_UserSelected_ServiceId"]) : '';
    $postchi_UserSelected_ServicePrice = $_POST["postchi_UserSelected_ServicePrice"] ? intval($_POST["postchi_UserSelected_ServicePrice"]) : get_option('postchi_woo_shipping_opts')["fixedShippingPriceValue"];
    $postchi_UserSelected_ServiceTitle = $_POST["postchi_UserSelected_ServiceTitle"] ? wp_kses($_POST["postchi_UserSelected_ServiceTitle"] , array()) : 'نرخ ثابت';
    $postchi_IsCOD = $_POST["postchi_IsCOD"] ? wp_kses($_POST["postchi_IsCOD"] , array()) : '';
    
    WC()->session->set("postchi_reciever_stateId", $postchi_reciever_stateId );
    WC()->session->set("postchi_reciever_stateTitle", $postchi_reciever_stateTitle );
    WC()->session->set("postchi_reciever_townId", $postchi_reciever_townId );
    WC()->session->set("postchi_reciever_townTitle", $postchi_reciever_townTitle );
    WC()->session->set("postchi_reciever_listType", $postchi_reciever_listType );
    WC()->session->set("postchi_UserSelected_ServiceId", $postchi_UserSelected_ServiceId );
    WC()->session->set("postchi_UserSelected_ServicePrice", $postchi_UserSelected_ServicePrice );
    WC()->session->set("postchi_UserSelected_ServiceTitle", $postchi_UserSelected_ServiceTitle );
    WC()->session->set("postchi_IsCOD", $postchi_IsCOD );

    die();
}

// Check Conditional Shipping
add_action( 'wp_ajax_ajaxCheckConditionalShipping', 'ajaxCheckConditionalShipping' );
add_action( 'wp_ajax_nopriv_ajaxCheckConditionalShipping', 'ajaxCheckConditionalShipping' );
function ajaxCheckConditionalShipping()
{
    check_ajax_referer( 'nonce-ajaxCheckConditionalShipping', 'security' );

    global $woocommerce; 

    $reciever_stateId = $_POST["postchi_reciever_stateId"] ? intval($_POST["postchi_reciever_stateId"]) : get_option('postchi_woo_shipping_opts')["reciver_default_stateId"];
    $reciever_townId = $_POST["postchi_reciever_townId"] ? intval($_POST["postchi_reciever_townId"]) : get_option('postchi_woo_shipping_opts')["reciver_default_townId"];  
    $cart_total_price = floatval( preg_replace('#[^\d.]#', '', $woocommerce->cart->get_cart_total()) );

    $check_conditionalShipping_result = postchi_isThereAShippingCondition($reciever_stateId, $reciever_townId, $cart_total_price);

    if( $check_conditionalShipping_result->is_there_a_condition )
        echo "true";
    else    
        echo "false";

    die();
}


// Store cart weight in the database
add_action('woocommerce_checkout_update_order_meta', 'postchi_add_cart_weight');
function postchi_add_cart_weight( $order_id )
{
    global $woocommerce;
    
    $weight = $woocommerce->cart->cart_contents_weight;
    update_post_meta( $order_id, 'cart_weight', $weight );
}


// Just use postchi shipping method
function just_postchi_shipping_method( $methods ) 
{
	$filtered_methods = array();
    foreach( $methods as $method_id => $method )
    {
        if( 'postchi_shipping' === $method->id )
        {
			$filtered_methods[ $method_id ] = $method;
			break;
		}
	}
    return !empty( $filtered_methods ) ? $filtered_methods : $methods;
}
add_filter( 'woocommerce_package_rates', 'just_postchi_shipping_method', 100 );


// override 'shipping debug' and 'shipping destination'
add_action( 'admin_init', 'postchi_override_shipping_debug');
function postchi_override_shipping_debug(){
    update_option('woocommerce_shipping_debug_mode','yes');
    update_option('woocommerce_ship_to_destination','billing_only');
}


// dont show debug mode message
add_filter( 'woocommerce_add_message', 'postchi_filtered_woo_messages' );
function postchi_filtered_woo_messages( $message ) {
    if(strpos($message, 'Customer matched zone') !== false)
    {
        return false;
    }  
}